# std::bad_variant_access

From cppreference.com
< cpp‎ | utility‎ | variant

Defined in header `<variant>` |  |
class bad_variant_access : public std::exception |  | (since C++17)

`std::bad_variant_access` is the type of the exception thrown in the following situations:

- `std::get(std::variant)` called with an index or type that does not match the currently active alternative
- `std::visit` called to visit a variant that is `valueless_by_exception`

### Member functions

(constructor) | bad_variant_access() (public member function)

## std::bad_variant_access ::bad_variant_access()

bad_variant_access(); |  |

Constructs a new instance of `std::bad_variant_access`.

### Parameters

(none)

### Exceptions

`noexcept` specification:
noexcept

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

### Example

Run this code

    #include <variant>
    #include <iostream>

    int main()
    {
        std::variant<int, float> v;
        v = 12;
        try {
          std::get<float>(v);
        }
        catch(const std::bad_variant_access& e) {
            std::cout << e.what() << '\n';
        }
    }

Possible output:

    bad_variant_access

### See also

std::get(std::variant) (C++17) | reads the value of the variant given the index or the type (if the type is unique), throws on error (function template)
visit (C++17) | calls the provided functor with the arguments held by one or more variants (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/variant/bad_variant_access&oldid=91862"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template